/*
 * Observable.hpp
 *
 *  Created on: Mar 23, 2016
 *      Author: tonpoppe
 */

#ifndef TEXTDEBLURPAN_OBSERVABLE_HPP_
#define TEXTDEBLURPAN_OBSERVABLE_HPP_

#include <vector>

#include "../textDeblurPanGui/Observer.hpp"

/**
 * class which implement the observer role of the observer pattern.
 */
class Observable {
  private:
    std::vector < class Observer * > views; // vector for storing observers
  public:
    void attach(Observer *obs);
    void notify(double fraction);
    void detach(Observer *obs);
};


#endif /* TEXTDEBLURPAN_OBSERVABLE_HPP_ */
