/*
 * DeblurAdapter.hpp
 *
 * @author  T. Poppe
 * @author  E. van Schaijk
 * @version  1.0
 * @since  July, 2016
 */

#ifndef TEXTDEBLURPANGUI_DEBLURADAPTER_HPP_
#define TEXTDEBLURPANGUI_DEBLURADAPTER_HPP_

#include <libgimp/gimp.h>
#include "DeblurPanPlugin.h"

  #ifdef __cplusplus
   extern "C" {
  #endif

  int deblurFromGimp(DeblurParam deblurParam, DeblurImageData deblurImageData);
  int getMaxKernelSize(gint x, gint y);


  #ifdef __cplusplus
    }
  #endif


#endif /* TEXTDEBLURPANGUI_DEBLURADAPTER_HPP_ */
