/*
 * deblurDialog.h
 *
 * @author  T. Poppe
 * @author  E. van Schaijk
 * @version  1.0
 * @since  July, 2016
 *
 * Module for displaying the GUI which is used for setting the deblur parameter values.
 */

#ifndef TEXTDEBLURPANGUI_DEBLURDIALOG_H_

#define TEXTDEBLURPANGUI_DEBLURDIALOG_H_

#include "DeblurPanPlugin.h"

/*
 * Shows the dialog in which the user can enter the deblur parameters
 */
gboolean blur_dialog(DeblurParam *deblurParam, DeblurParam *deblurParamDefaults, GimpDrawable *drawable);



#endif /* TEXTDEBLURPANGUI_DEBLURDIALOG_H_ */
