/*
 * Observer.hpp
 *
 * @author  T. Poppe
 * @author  E. van Schaijk
 * @version  1.0
 * @since  July, 2016
 *
 * Virtual class to implement the Observer pattern
 *
 */

#ifndef TEXTDEBLURPANGUI_OBSERVER_HPP_
#define TEXTDEBLURPANGUI_OBSERVER_HPP_

class Observer {
  private:

  public:
	virtual ~Observer(){};
	virtual void update(double fraction) = 0;
};



#endif /* TEXTDEBLURPANGUI_OBSERVER_HPP_ */
